// oneOnOneRules.cpp : Defines the entry point for the DLL application.
//

#include "bzfsAPI.h"

BZ_GET_PLUGIN_VERSION

class oneOnOneRules : public bz_EventHandler
{
public:
	bool do_flagreset;

	virtual void process(bz_EventData *eventData);

	bool enforce_rules;
};

oneOnOneRules oneOnOne;

BZF_PLUGIN_CALL int bz_Load (const char* commandLine)
{
	oneOnOne.do_flagreset = (*commandLine == 'r' ? true : false);
	oneOnOne.enforce_rules = false;

  bz_registerEvent (bz_ePlayerDieEvent, &oneOnOne);
  bz_debugMessage(4,"oneOnOneRules plugin loaded");
  return 0;
}

BZF_PLUGIN_CALL int bz_Unload ( void )
{
  bz_removeEvent (bz_ePlayerDieEvent, &oneOnOne);
  bz_debugMessage(4,"oneOnOneRules plugin unloaded");
  return 0;
}

void oneOnOneRules::process(bz_EventData *eventData)
{
	int totaltanks = 
		bz_getTeamCount (eRogueTeam) +
		bz_getTeamCount (eRedTeam) +
		bz_getTeamCount (eGreenTeam) +
		bz_getTeamCount (eBlueTeam) +
		bz_getTeamCount (ePurpleTeam) +
		bz_getTeamCount (eRabbitTeam);

	if (totaltanks == 2)
	{
		if (!enforce_rules)
		{
			enforce_rules = true;
			bz_sendTextMessage (BZ_SERVER, BZ_ALLUSERS, "One-on-one rules are in effect.");
		}
	}
	else
	{
		if (enforce_rules)
		{
			enforce_rules = false;
			bz_sendTextMessage (BZ_SERVER, BZ_ALLUSERS, "One-on-one rules have been lifted.");
		}
	}

	if (enforce_rules)
	{
		bz_PlayerDieEventData* killdata = (bz_PlayerDieEventData*)eventData;

		//team flags don't count
		if (killdata->flagKilledWith != "R*" && killdata->flagKilledWith != "G*" && killdata->flagKilledWith != "B*" && killdata->flagKilledWith != "P*")
		{
			if (do_flagreset)
			{
				bz_resetFlags (false);
			}
			else
			{
				bz_removePlayerFlag(killdata->killerID);
			}
		}
	}
}
// Local Variables: ***
// mode:C++ ***
// tab-width: 8 ***
// c-basic-offset: 2 ***
// indent-tabs-mode: t ***
// End: ***
// ex: shiftwidth=2 tabstop=8

